<template>
  <div class="content" v-if="user">
    <header>
      <GoBackButton :target="this.$route.params.user" />
      <div class="row">
        <div class="col-12 text-right">
          <img :src="user.photoURL" class="avatar centered-picture d-block">
        </div>
      </div>
    </header>

    <section class="container text-center">
      <h1>{{ user.displayName }}</h1>
      <p v-if="user.gender">
        {{ user.gender }}, {{ user.age }}
        <template v-if="user.phoneNumber">
          <br>
          Telefone: {{ user.phoneNumber }}
        </template>
      </p>
    </section>

    <section class="container text-center">
      <button v-if="!allowEdit" @click="allowEdit = !allowEdit;"> Editar </button>
    </section>

    <section class="container" v-if="allowEdit">
      <form class="col-12">
        <div class="form-group">
          <label for="userDisplayName">Nome</label>
          <input type="text" v-model="user.displayName" class="form-control" id="userDisplayName">
        </div>

        <div class="form-group">
          <label for="userPhoneNumber">Telefone</label>
          <input type="text" v-model="user.phoneNumber" class="form-control" id="userPhoneNumber">
        </div>

        <div class="form-group">
          <label for="userAge">Idade</label>
          <input type="number" v-model="user.age" class="form-control" id="userAge">
        </div>

        <div class="form-group">
          <label for="inputState">Gênero</label>
          <select v-model="user.gender" id="inputState" class="form-control">
            <option disabled value="">Escolha um item</option>
            <option value="Masculino">Masculino</option>
            <option value="Feminino">Feminino</option>
          </select>
        </div>

        <button @click="updateUserOnFirestore">Salvar</button>
      </form>
    </section>

    <section class="container mt-4" v-if="false">
      <h2>Histórico de questionarios</h2>

      <div class="row historic">
        <div class="col-3">
          <span>01 JAN</span>
        </div>
        <div class="col-9">
          <p>Titulo</p>
          <p>Orientação</p>
        </div>
      </div>

      <div class="row historic">
        <div class="col-3">
          <span>01 JAN</span>
        </div>
        <div class="col-9">
          <p>Titulo</p>
          <p>Orientação</p>
        </div>
      </div>
    </section>
  </div>
</template>

<script>
export default {
  data() {
    return {
      user: null,
      allowEdit: false,
    };
  },

  mounted() {
    this.$fire.auth.onAuthStateChanged(user => {
      this.getUserFromFirestore(user.uid);
    });
  },

  methods: {
    async getUserFromFirestore(uid) {
      const currentUser = this.$fire.firestore
        .collection('Users')
        .doc(uid)
      try {
        const snapshot = await currentUser.get()
        const doc = snapshot.data()
        if (!doc) {
          alert('Document does not exist.')
          return
        }
        this.user = doc;
      } catch (e) {
        alert(e)
      }
    },

    async updateUserOnFirestore() {
      this.allowEdit = false;

      const newUser = this.$fire.firestore
        .collection('Users')
        .doc(this.user.uid)
      try {
        await newUser.update({
          displayName: this.user.displayName,
          phoneNumber: this.user.phoneNumber,
          gender: this.user.gender,
          age: this.user.age,
        })
      } catch (e) {
        alert(e)
        return
      }
    },
  },
}
</script>

<style scoped>
  .content {
    margin-bottom: 1rem;
  }

  header {
    margin-bottom: 6rem;
  }

  .avatar {
    position: absolute;
    top: 0;
    left: 50%;
    transform: translate(-50%, -20%);
    width: 140px;
    border-radius: 15% !important;
    box-shadow: 0 5px 13px -12px #000;
  }

  h1 {
    color: #000001;
    font-size: 18px;
    font-weight: bolder;
  }

  h2 {
    font-size: 17px;
    font-weight: bold;
    text-transform: uppercase;
  }

  p {
    color: #9D9D9F;
    font-size: 12px;
  }

  .historic {
    padding: .5rem 0;
    margin-bottom: 1rem;
  }

  .historic p {
    margin: 0;
    color: #000001;
  }

  .historic p:first-child {
    font-weight: 600;
    color: #9D9D9F;
  }

  .historic span {
    color: #9D9D9F;
    font-size: 12px;;
  }
</style>
